package com.university;

import java.util.ArrayList;

public class Department {

    String name;
    ArrayList<Student> stuu = new ArrayList<>();
    ArrayList<Course> courses = new ArrayList<>();
    ArrayList<Professor> professors = new ArrayList<>();
    public Department(String name) {
        this.name = name;
    }

    public String getName(){
        return name;
    }

    public void addStudent(Student student){
        if(student.getDepartment().getName().equals(this.getName()))
            stuu.add(student);
    }

    public Student[] getStudents(){
        Student[] studentArray = new Student[stuu.size()];
        if(stuu.size() == 0){
            return null;
        }else {
            return stuu.toArray(studentArray);
        }
    }

    public void removeStudent(Student student){
        if(student.getDepartment().getName().equals(this.getName()))
            stuu.remove(student);
    }

    public void addCourse(Course course){
        if(course.getDepartment().getName().equals(this.getName())){
            courses.add(course);
        }
    }

    public Course[] getCourses(){
        Course[] myCourse = new Course[courses.size()];
        if(courses.size() == 0){
            return null;
        }else {
            return courses.toArray(myCourse);
        }
    }

    public void removeCourse(Course course){
        if(course.getDepartment().getName().equals(this.getName())){
            courses.remove(course);
        }
    }

    public void addProfessor(Professor student){
        if(student.getDepartment().getName().equals(this.getName())){
            professors.add(student);
        }
    }

    public Professor[] getProfessors()
    {
        Professor[] myProfessor = new Professor[professors.size()];
        if(professors.size() == 0){
            return null;
        }else {
            return professors.toArray(myProfessor);
        }
    }

    public void removeProfessor(Professor professor){
        if(professor.getDepartment().getName().equals(this.getName())){
            professors.add(professor);
        }
    }

}
