package test;

import com.university.*;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

//class StudentTest {
//    static Student student;
//    static Course course;
//    static Department chem ;
//
//    @BeforeAll
//    public static void creatStudentTest() {
//        student = new Student("Milad" , "9731007" , "Com" , new Department("Com"));
//        course = new Course("1" , "AP" , new Department("Com") , new Professor(new Department("Com") , "Farzin"), 0 );
//        course.enrollStudent(student);
//    }
//
//    @Test
//    public void StudentNameTest(){
//        assertEquals("Milad" , student.getName());
//    }
//
//    @Test
//    public void courseTest(){
//        assertEquals("1" , course.getID());
//        assertNull(course.getStudents());
//    }
//
////    @Test
////    public void DepartmentTest(){
////        assertEquals();
////    }
//
//}

public class StudentTest {
    static Student student;
    static Student student2;
    static Department department;
    static Department department2;
    static Professor professor;
    static Professor professor2;
    static Course c1;
    static Course c2;
    static University uni;
    @BeforeAll
    public static void createStudent(){
        department = new Department("Computer and IT Eng");
        department2 = new Department("Chemistry");
        student = new Student("Alireza", "1234", "Software Eng", department);
        student2 = new Student("Milad" , "1235" , "Chem" , department2);
        professor = new Professor(department , "Kalbasi");
        professor2 = new Professor(department2 , "Noshad");
        c1 = new Course("2" , "Chem" , department2 , professor , 200 );
        c2 = new Course("1" , "C" , department , professor , 200 );
        uni = new University();
    }

    @Test
    public void testStudentGetName(){
        assertEquals("Alireza", student.getName());
    }


    @Test
    public void testStudentID(){
        assertEquals("1234" , student.getID());
    }

    @Test
    public void testStudentMajor(){
        assertEquals("Software Eng" , student.getMajor());
    }

    @Test
    public void testAddCourse(){
        student.addCourse(c1);
        assertNull(student.getCourses());
        student.addCourse(c2);
        assertNotNull(student.getCourses());
    }

    @Test
    public void testCourseID(){
        assertEquals("2" , c1.getID());
    }

    @Test
    public void testGetDepartment(){
        assertNotNull(c1.getDepartment());
    }

    @Test
    public void testCourseGetName(){
        assertEquals("Chem" , c1.getName());
    }

    @Test
    public void testCourseGetProfessor(){
        assertNotNull(c1.getProfessor());
    }

    @Test
    public void testEnrollStudent(){
        c2.enrollStudent(student2);
        assertNull(c1.getStudents());
        c2.enrollStudent(student);
        assertNotNull(c2.getStudents());
    }

    @Test
    public void testDepartmentAddStudent(){
        department.addStudent(student2);
        assertNull(department.getStudents());
        department.addStudent(student);
        assertNotNull(department.getStudents());
    }

    @Test
    public void testDepartmentRemoveStudent(){
        department.removeStudent(student2);
        assertNotNull(department.getStudents());
        department.removeStudent(student);
        assertNull(department.getStudents());
    }

    @Test
    public void testDepartmentGetName(){
        assertEquals("Computer and IT Eng" , department.getName());
    }

    @Test
    public void testDepartmentAddCourse(){
        department.removeCourse(c2);
        department.addCourse(c1);
        assertNull(department.getCourses());
        department.addCourse(c2);
        assertNotNull(department.getCourses());
    }

    @Test
    public void testDepartmentRemove(){
        department.removeCourse(c1);
        assertNotNull(department.getCourses());
        department.removeCourse(c2);
        assertNull(department.getCourses());
    }

    @Test
    public void testDepartmentAddProfessor(){
        department.addProfessor(professor2);
        assertNull(department.getProfessors());
        department.addProfessor(professor);
        assertNotNull(department.getProfessors());
    }

    @Test
    public void testDepartmentGetCourse(){
        assertNotNull(department.getCourses());
    }

    @Test
    public void testProfessorGetDepartment(){
        assertEquals(department , professor.getDepartment());
    }
    @Test
    public void testProfessorName(){
        assertEquals("Kalbasi" ,professor.getName());
    }
    @Test
    public void testProfessorGetCourse(){
        department.addCourse(c2);
        assertNotNull(professor.getCourses());
    }

    @Test
    public void testAddDepartmentUniversity(){
        assertNull(uni.getDepartments());
        uni.addDepartment(department);
        assertNotNull(uni.getDepartments());
    }

}