package com.university;

import java.util.ArrayList;

public class Course {
    String ID;
    String name;
    Department department;
    Professor professor;
    int credit;
    ArrayList<Student> stu = new ArrayList<>();


    public Course(String ID, String name, Department department, Professor professor, int credit) {
        this.ID = ID;
        this.name = name;
        this.department = department;
        this.professor = professor;
        this.credit = credit;
    }

    public String getID(){
        return ID;
    }

    public Department getDepartment(){
        return department;
    }

    public String getName() {
        return name;
    }

    public Student[] getStudents() {
        Student[] studentArray = new Student[stu.size()];
        if(stu.size() == 0){
            return null;
        }else {
            return stu.toArray(studentArray);
        }
    }

    public Professor getProfessor() {
        return professor;
    }

    public int getCredit() {
        return credit;
    }

    public  void enrollStudent(Student student){
        if(student.getDepartment().getName().equals(this.getDepartment().getName()))
            stu.add(student);
    }

}
