package com.university;

import java.util.ArrayList;

public class Professor {

    Department department;
    String name;
    ArrayList<Course> proCourse = new ArrayList<>();
    public Professor(Department department, String name) {
        this.department = department;
        this.name = name;
    }

    public Department getDepartment() {
        return department;
    }

    public String getName() {
        return name;
    }

    public Course[] getCourses() {
        for (Course aCourse:department.getCourses()) {
            if(aCourse.getProfessor().getName().equals(this.getName())){
                proCourse.add(aCourse);
            }
        }
        Course[] courseArray = new Course[proCourse.size()];
        if(proCourse.size() == 0){
            return null;
        }else {
            return proCourse.toArray(courseArray);
        }
    }
}
