package com.university;

import java.util.ArrayList;
import java.util.Collections;

public class Student {


    String name;
    String ID;
    String major;
    Department department;
    ArrayList<Course> a = new ArrayList<>();

    public Student(String name, String ID, String major, Department department) {
        this.name = name;
        this.ID=ID;
        this.major = major ;
        this.department = department;
    }


    public String getName() {
        return name;
    }

    public String getID() {
        return ID;
    }

    public String getMajor() {
        return major;
    }

    public Department getDepartment() {
        return department;
    }

    public Course[] getCourses() {
        Course[] b = new Course[a.size()];
        if(a.size() == 0){
            return null;
        }else {
            return a.toArray(b);
        }
    }

    public void addCourse(Course course){
        if(course.getDepartment().getName().equals(this.getDepartment().getName())){
            a.add(course);
        }
    }
}
